---
- name: Create individual user account for subject
  become: true
  when:
    - (subject.name in role.subjects)
  block:
    - name: Create individual user group
      ansible.builtin.group:
        name: "{{ subject.name }}"
        state: present
      loop: "{{ user_subjects }}"
      loop_control:
        loop_var: subject
        label: "{{ subject.name }}"

    - name: Create individual user account
      ansible.builtin.user:
        name: "{{ subject.name }}"
        group: "{{ subject.name }}"
        shell: "{{ subject.shell | default('/bin/bash') }}"
        groups: "{{ [role.account] + role.permissions.groups | default([]) | list }}"
        append: true
      loop: "{{ user_subjects }}"
      loop_control:
        loop_var: subject
        label: "{{ subject.name }}"

    - name: Set SSH directory
      ansible.builtin.file:
        state: directory
        name: /home/{{ subject.name }}/.ssh
        owner: "{{ subject.name }}"
        group: "{{ subject.name }}"
        mode: 0700
      loop: "{{ user_subjects }}"
      loop_control:
        loop_var: subject
        label: "{{ subject.name }}"

    - name: Set public key
      ansible.builtin.copy:
        content: "{{ subject.key_format | default ('ssh-rsa') }} {{ subject.public_key }} {{ subject.name }}"
        dest: /home/{{ subject.name }}/.ssh/authorized_keys
        owner: "{{ subject.name }}"
        group: "{{ subject.name }}"
        mode: 0600
      loop: "{{ user_subjects }}"
      loop_control:
        loop_var: subject
        label: "{{ subject.name }}"
